/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.contents.text;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Collection;
import kinugasa.contents.resource.ContentsFileNotFoundException;
import kinugasa.contents.resource.Freeable;
import kinugasa.contents.resource.ContentsIOException;
import kinugasa.contents.resource.IllegalFormatException;
import kinugasa.contents.resource.Loadable;
import kinugasa.game.GameLog;

/**
 * テキストファイルを読む込むためのTextIOの実装です.
 * <br>
 * ファイルを読み込む際には、読み込み対象となるファイルが存在していなければならないので、 コンストラクタではファイルの有無を確認します。<br>
 * <br>
 *
 * @param <T> テキストファイルのある1行の内容を表すクラスを指定します。 たとえば、CSVファイルではString[]です。<br>
 *
 * @version 1.0.0 - 2013/01/13_20:02:58<br>
 * @author Dra0211<br>
 */
public abstract class TextReader<T> extends TextIO<T> implements Freeable, Loadable {

	private static final long serialVersionUID = 8671421693215761665L;
	/**
	 * このテキストファイルを読み込むためのリーダです.
	 */
	private Reader<T> reader;

	/**
	 * ファイルパスとリーダを指定して、読み込み用ファイルを構築します.
	 *
	 * @param filePath ファイルパスを指定します。<br>
	 * @param parser 文字列を解析するリーダを指定します。<br>
	 *
	 * @throws ContentsFileNotFoundException 指定されたファイルが存在しない場合に投げられます。<br>
	 */
	public TextReader(String filePath, Reader<T> parser) throws ContentsFileNotFoundException {
		super(filePath);
		if (!file.exists()) {
			throw new ContentsFileNotFoundException("file not found : file=[" + getName() + "]");
		}
		this.reader = parser;
	}

	/**
	 * ファイルとリーダを指定して、読み込み用ファイルを構築します.
	 *
	 * @param file ファイルを指定します。<br>
	 * @param parser 文字列を解析するリーダを指定します。<br>
	 *
	 * @throws ContentsFileNotFoundException 指定されたファイルが存在しない場合に投げられます。<br>
	 */
	public TextReader(File file, Reader<T> parser) throws ContentsFileNotFoundException {
		super(file);
		if (!file.exists()) {
			throw new ContentsFileNotFoundException("file not found : file=[" + getName() + "]");
		}
		this.reader = parser;
	}

	/**
	 * テキストファイルのデータをロードします.
	 *
	 * @return thisインスタンスを返します。<br>
	 *
	 * @throws IllegalFormatException パーサが文字列を解析できない場合に投げられます。<br>
	 * @throws ContentsIOException ファイルをロードできない場合に投げられます。<br>
	 */
	@Override
	public TextReader<T> load() throws IllegalFormatException, ContentsIOException {
		FileReader fr = null;
		BufferedReader br = null;
		try {
			fr = new FileReader(file);
			br = new BufferedReader(fr);
			for (String line; (line = br.readLine()) != null;) {
				T val = reader.parse(line);
				if (val != null) {
					add(val);
				}
			}
			GameLog.printInfoIfUsing("TextReader（ロード）[" + file.getName() + "] size=[" + size() + "]");
		} catch (java.io.IOException ex) {
			throw new ContentsIOException(ex);
		} finally {
			try {
				if (br != null) {
					br.close();
				}
				if (fr != null) {
					fr.close();
				}
			} catch (java.io.IOException ex) {
				throw new ContentsIOException(ex);
			}
		}
		return this;
	}

	/**
	 * 全てのデータを破棄します.
	 *
	 * @return thisインスタンスを返します。 <br>
	 */
	@Override
	public TextReader<T> free() {
		return clear();
	}

	@Override
	public boolean isLoaded() {
		return !data.isEmpty();
	}

	@Override
	public TextReader<T> add(Collection<? extends T> obj) {
		return (TextReader<T>) super.add(obj);
	}

	@Override
	public TextReader<T> add(T obj) {
		return (TextReader<T>) super.add(obj);
	}

	@Override
	public TextReader<T> add(T... obj) {
		return (TextReader<T>) super.add(obj);
	}

	@Override
	public TextReader<T> add(TextIO<? extends T> other) {
		return (TextReader<T>) super.add(other);
	}

	@Override
	public TextReader<T> remove(Collection<? extends T> obj) {
		return (TextReader<T>) super.remove(obj);
	}

	@Override
	public TextReader<T> remove(T obj) {
		return (TextReader<T>) super.remove(obj);
	}

	@Override
	public TextReader<T> remove(T... obj) {
		return (TextReader<T>) super.remove(obj);
	}

	@Override
	public TextReader<T> remove(TextIO<? extends T> other) {
		return (TextReader<T>) super.remove(other);
	}

	@Override
	public TextReader<T> clear() {
		return (TextReader<T>) super.clear();
	}

	/**
	 * リーダを取得します.
	 *
	 * @return このテキストファイルを解析するためのリーダを返します。<br>
	 */
	public Reader<T> getReader() {
		return reader;
	}

	/**
	 * リーダを設定します.
	 *
	 * @param reader このテキストファイルを解析するためのリーダを設定します。<br>
	 */
	public void setReader(Reader<T> reader) {
		this.reader = reader;
	}
}
